var fs = require('fs');
var Writable = require('stream').Writable;

var defaultInterval = 36e5;
function defaultAppendFileName(part) {
  return '_part'+part;
}

exports =
module.exports =
function rotateFileStream (path, options, srcOpts) {
  var interval = options.interval || defaultInterval;
  var appendFileName = options.appendFileName || defaultAppendFileName;

  var nPart = 0;
  var f = fs.createWriteStream(path+appendFileName(nPart++), options);

  var rotatations = setInterval(rotate, interval);

  function rotate () {
    f.end();
    f = fs.createWriteStream(path+appendFileName(nPart++), options);
  }


  var w = new Writable(srcOpts);

  w._write = function (chunk, encoding, next) {
    f.write(chunk, {
      encoding: encoding
    });
    next();
  }

  w.on('finish', function () {
    clearInterval(rotatations);
    f.end();
  });

  return w;
};
