var fs = require('fs');
var rotateFileStream = require('../');
var JSONStream = require('JSONStream');
var concatParts = require('./utils/concat-parts');
var stdev = require('stdev');
var test = require('tap').test;

var written = 0;
test('create the files', function (t) {
  var jstr = JSONStream.stringify();

  var rfs = rotateFileStream(__dirname+'/results/interval', {
    interval: 100,
    appendFileName: function (i) {
      return '_part'+i+'.txt';
    }
  });

  jstr.pipe(rfs);

  var writeInt = setInterval(write, 50);
  var endInt = setTimeout(end, 2000);

  function write () {
    written++;
    jstr.write(Date.now());
  }

  function end () {
    clearInterval(writeInt);
    jstr.end();
    t.ok(written > 0, 'wrote more than 0');
    t.end();
  }
});

var results;
test('all the values are there', function (t) {
  results = JSON.parse(concatParts(/interval\_part\d+?\.txt/));
  t.equal(results.length, written);
  t.end();
});

test('the stdev is as expected', function (t) {
  var moreOrLess = Math.floor(stdev(results));
  t.ok(moreOrLess > 560 && moreOrLess < 580);
  t.end();
});

test('delete the files', function (t) {
  fs.readdir(__dirname+'/results', function (err, files) {
    t.ok(!err);
    files.forEach(function (file) {
      if (file === '.gitkeep')
        return;
      fs.unlinkSync(__dirname+'/results/'+file);
    });
    t.end();
  });
});
