var fs = require('fs');
var rotateFileStream = require('../');
var concatParts = require('./utils/concat-parts');
var test = require('tap').test;

test('pipe to parts', function (t) {
  var rfs = rotateFileStream(__dirname+'/results/pipe', {
    interval: 100,
    appendFileName: function (i) {
      return '_part'+i+'.txt';
    }
  });

  var qx = fs.createReadStream(__dirname + '/fixtures/pg22970.txt')
  qx.pipe(rfs);
  
  qx.on('end', t.end.bind(t));
});


test('no difference between the original', function (t) {
  var original = fs.readFileSync(__dirname + '/fixtures/pg22970.txt', {
    encoding: 'utf8'
  });

  var result = concatParts(/pipe\_part\d+?\.txt/);
  t.equal(result, original);
  t.end();
});


function xtest() {};
test('delete the files', function (t) {
  fs.readdir(__dirname+'/results', function (err, files) {
    t.ok(!err);
    files.forEach(function (file) {
      if (file === '.gitkeep')
        return;
      fs.unlinkSync(__dirname+'/results/'+file);
    });
    t.end();
  });
});
